| IGLib 1.4 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Properties | Private Attributes

# IG::Neural::NeuralTrainingParameters Class Reference

Contains Parameters that define neural network architecture and trainig procedure, together with achieved results after training such as various error norms. Not thread safe! More...

Collaboration diagram for IG::Neural::NeuralTrainingParameters:
[legend]

List of all members.

## Classes
class | ComparerBase
| Base comparer class (implementation of the IComparer<NeuralTrainingParameters> interface) for conmparing objects of type NeuralTrainingParameters More...
class | ComparerErrorTrainingVector
class | ComparerTrainingTime
## Public Member Functions
void | SetEpochNumbers (int[] epochNumbers)
| Sets the list of epoch numbers at which convergence data was sampled.
void | SetEpochNumbers (List< int > epochNumbers)
| Sets the list of epoch numbers at which convergence data was sampled.
void | SetEpochErrorsRms (double[] errors)
| Sets the list of sampled RMS errors that correspond to epoch numbers from EpochNumbers.
void | SetEpochErrorsRms (List< double > errors)
| Sets the list of sampled RMS errors corresponding to epoch numbers from EpochNumbers.
void | SetEpochErrorsAbs (double[] errors)
| Sets the list of sampled absolute errors that correspond to epoch numbers from EpochNumbers.
void | SetEpochErrorsAbs (List< double > errors)
| Sets the list of sampled absolute errors corresponding to epoch numbers from EpochNumbers.
void | CopyFrom (NeuralApproximatorBase nn)
| Copies current data from the specified neural network approximator.
void | CopyResultsFrom (NeuralApproximatorBase nn)
| Copies only results from the trained network to the current object.
void | CopyTo (NeuralApproximatorBase nn)
| Copies data that determine neural network and training procedure (such as network architecture, training parameters, tolerances, etc.) from the current object to the specified neural network approximator. This enables to restore training contitions of a peviour training procedure.
## Static Public Member Functions
static void | SaveJson (NeuralTrainingParameters trainingParameters, string filePath)
| Saves (serializes) the specified training parameters object to the specified JSON file. File is owerwritten if it exists.
static void | SaveJson (NeuralTrainingParameters trainingParameters, string filePath, bool append)
| Saves (serializes) the specified training parameters object to the specified JSON file.
static void | LoadJson (string filePath, ref NeuralTrainingParameters trainingParametersRestored)
| Restores (deserializes) a training parameters object from the specified file in JSON format.
static void | SaveJson (NeuralTrainingParameters[] trainingParameters, string filePath)
| Saves (serializes) the specified array of training parameters objects to the specified JSON file. File is owerwritten if it exists.
static void | SaveJson (NeuralTrainingParameters[] trainingParameters, string filePath, bool append)
| Saves (serializes) the specified array of training parameters objects to the specified JSON file.
static void | LoadJson (string filePath, ref NeuralTrainingParameters[] trainingParametersRestored)
| Restores (deserializes) an array of training parameters objects from the specified file in JSON format.
static void | SaveJson (List< NeuralTrainingParameters > trainingParameters, string filePath)
| Saves (serializes) the specified list of training parameters objects to the specified JSON file. File is owerwritten if it exists.
static void | SaveJson (List< NeuralTrainingParameters > trainingParameters, string filePath, bool append)
| Saves (serializes) the specified list of training parameters objects to the specified JSON file.
static void | LoadJson (string filePath, ref List< NeuralTrainingParameters > trainingParametersRestored)
| Restores (deserializes) a list of training parameters objects from the specified file in JSON format.
static void | SaveCSV (List< NeuralTrainingParameters > trainingParameters, string filePath)
| Saves the specified list of training parameters objects to the specified CSV file.
static ComparerTrainingTime | CreateComparerTrainingTime ()
## Public Attributes
List< IVector > | _errorsTrainingRmsList = null
List< IVector > | _errorsTrainingMaxList = null
List< IVector > | _errorsVerificationRmsList = null
List< IVector > | _errorsVerificationMaxList = null
bool | _convergenceRmsEnabled = false
## Static Public Attributes
static double | DefaultLearningRate = 0.1
| Default value for learning rate in neural networks.
static double | DefaultMomentum = 0.5
| Default value of momentum for neural networks.
static double | DefaultSigmoidAlphaValue = 1.5
| Default value of the sigmoid alpha value (used in networks with sigmoid activation functions).
static int | DefaultEpochsInBundle
| Default value for number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between).
static int | DefaultNumHiddenLayers = 1
| Default number of hidden layers.
static int | DefaultNumHiddenNeurons = 20
| Default number of hidden neurons in a layer.
static int | DefaultMaxEpochs = 40000
| Default value for maximal number of epochs.
static IVector | DefaultToleranceRms = null
| Default value for tollerance on RMS error in neural networks.
static IVector | DefaultToleranceMax = null
| Default value for tollerance on max. abs. error in neural networks.
static double | DefaultToleranceRmsRelativeToRangeScalar = 0.1
| Default value for the tolerance on RMS error, relative to the output range.
static double | DefaultToleranceMaxRelativeToRangeScalar = 0
| Default value for the tolerance on max. abs. error, relative to the output range.
static int | DefaultInputLength = 1
| Default number of input neurons.
static int | DefaultOutputLength = 1
| Default number of output neurons.
static double | DefaultInputBoundSafetyFactor = 1.5
| Default number of input safety factor.
static double | DefaultOutputBoundSafetyFactor = 1.5
| Default number of output safety factor.
## Protected Member Functions
IComparer< IVector > | CreateComparerErrorTrainingRmsVector ()
## Static Protected Member Functions
static double | ErrorAverageCalc (List< IVector > ErrorConvergence, int NumLastErrors, int NumBundles, IVector scalingLength)
| Calculate average number of the desired number of first elements in the convergence list.
static double | ErrorAverageCalc (List< IVector > ErrorConvergence, int NumLastErrors, int NumBundles)
| Calculate average number of the desired number of first elements in the convergence list.
## Protected Attributes
double | _learningRate = DefaultLearningRate
double | _momentum = DefaultMomentum
double | _sigmoidAlphaValue = DefaultSigmoidAlphaValue
int | _maxEpochs = DefaultMaxEpochs
int | _epochInBundle = DefaultEpochsInBundle
IVector | _outputRange
IBoundingBox | _outputNeuronRange
IVector | _inputRange
IBoundingBox | _inputNeuronRange
IVector | _toleranceRms
IVector | _toleranceMax
int | _numHiddenLayers = DefaultNumHiddenLayers
int[] | _numHiddenNeurons = null
bool | _isNetworkTrained = false
IVector | _errorsTrainingRms
IVector | _errorsTrainingMax
IVector | _errorsTrainingMeanAbs
IVector | _errorsVerificationRms
IVector | _errorsVerificationMax
IVector | _errorsVerificationMeanAbs
int | _numEpochs = 0
double | _trainingTime = 0
double | _trainingCpuTime = 0
List< int > | _EpochNumbers
List< double > | _EpochErrorsRms
List< double > | _EpochErrorsAbs
## Properties
double | LearningRate`[get, set]`
| Learning rate.
double | Momentum`[get, set]`
| Momentum. Specifies how much changes of weight in the previous iterations affect changes in the current iterations.
double | SigmoidAlphaValue`[get, set]`
| Sigmoid alpha value (used in networks with sigmoid activation functions).
virtual int | InputLength`[get, set]`
| Gets or sets the number of input neurons.
virtual int | OutputLength`[get, set]`
| Gets or sets the number of output neurons.
virtual double | InputBoundSafetyFactor`[get, set]`
| Gets or sets input safety factor.
virtual double | OutputBoundSafetyFactor`[get, set]`
| Gets or sets output safety factor.
int | MaxEpochs`[get, set]`
| Maximal number of epochs performed in the training procedure.
int | EpochsInBundle`[get, set]`
| Number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between). This parameter does not affect the training procedure in terms of results.
IVector | OutputRange`[get, set]`
| Range from actual outputs.
IBoundingBox | OutputNeuronRange`[get, set]`
| Bounding box from actual outputs.
IVector | InputRange`[get, set]`
| Range from actual inputs.
IBoundingBox | InputNeuronRange`[get, set]`
| Bounding box from actual inputs.
IVector | ToleranceRms`[get, set]`
| Tolerance over RMS error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.
IVector | ToleranceMax`[get, set]`
| Tolerance on maximal error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.
IVector | ToleranceRmsRelativeToRange`[get, set]`
| Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data.
double | ToleranceRmsRelativeToRangeScalar`[get, set]`
| Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value.
IVector | ToleranceMaxRelativeToRange`[get, set]`
| Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data.
double | ToleranceMaxRelativeToRangeScalar`[get, set]`
| Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value.
int | NumHiddenLayers`[get, set]`
| Number of Hideden layers.
int[] | NumHidenNeurons`[get, set]`
| Numbers of neurons in each hidden layer.
bool | IsNetworkTrained`[get, set]`
| Whether the network is trained (and results exist).
IVector | ErrorsTrainingRms`[get, set]`
| RMS errors calculated on training data.
List< IVector > | ErrorsTrainingRmsList`[get, set]`
| Convergence List of Rms errors calculated on training data.
IVector | ErrorsTrainingMax`[get, set]`
| Maximal errors calculated on training data.
List< IVector > | ErrorsTrainingMaxList`[get, set]`
| Convergence List of Maximal errors calculated on training data.
IVector | ErrorsTrainingMeanAbs`[get, set]`
| Mean absolute errors calculated on training data.
IVector | ErrorsVerificationRms`[get, set]`
| RMS errors calculated on verification data.
List< IVector > | ErrorsVerificationRmsList`[get, set]`
| Convergence List of RMS errors calculated on verification data.
IVector | ErrorsVerificationMax`[get, set]`
| Maximal errors calculated on verification data.
List< IVector > | ErrorsVerificationMaxList`[get, set]`
| Convergence List of Maximal errors calculated on verification data.
IVector | ErrorsVerificationMeanAbs`[get, set]`
| Maximal errors calculated on training data.
bool | SaveConvergenceRms`[get, set]`
int | NumEpochs`[get, set]`
| Number of epochs actually spent at training. This may be less than MaxEpochs if convergence is reached before.
double | TrainingTime`[get, set]`
| Time spent for training.
double | TrainingCpuTime`[get, set]`
| CPU time spent for training.
List< int > | EpochNumbers`[get, set]`
| List of epoch numbers at which convergence data was sampled.
List< double > | EpochErrorsRms`[get, set]`
| List of sampled RMS errors corresponding to epoch numbers from EpochNumbers.
List< double > | EpochErrorsAbs`[get, set]`
| List of sampled absolute errors corresponding to epoch numbers from EpochNumbers.
## Private Attributes
int | _inputLength = DefaultInputLength
int | _outputLength = DefaultOutputLength
double | _inputBoundSafetyFactor = DefaultInputBoundSafetyFactor
| Gets or sets input safety factor.
double | _outputBoundSafetyFactor = DefaultOutputBoundSafetyFactor
| Gets or sets output safety factor.
IVector | _tolRmsRelative
| Auxiliary properties for defining tolerances in a relative way:
double | _tolRmsRelativeScalar = DefaultToleranceRmsRelativeToRangeScalar
IVector | _tolMaxRelative
double | _tolMaxRelativeScalar = DefaultToleranceMaxRelativeToRangeScalar

## Detailed Description

Contains Parameters that define neural network architecture and trainig procedure, together with achieved results after training such as various error norms.

Not thread safe!

This class is used for storing parameters of neural networks and restoring them at a later time, in order to repeat training under similar condition or simply to analyse performance of neural networks. $A Igor May12;

## Member Function Documentation

void IG::Neural::NeuralTrainingParameters::SetEpochNumbers | ( | int[] | epochNumbers | ) | `[inline]`

Sets the list of epoch numbers at which convergence data was sampled.

Parameters:

  epochNumbers | Array of epoch numbers from which data is copied.

void IG::Neural::NeuralTrainingParameters::SetEpochNumbers | ( | List< int > | epochNumbers | ) | `[inline]`

Sets the list of epoch numbers at which convergence data was sampled.

Parameters:

  epochNumbers | List of epoch numbers from which data is copied.

void IG::Neural::NeuralTrainingParameters::SetEpochErrorsRms | ( | double[] | errors | ) | `[inline]`

Sets the list of sampled RMS errors that correspond to epoch numbers from EpochNumbers.

Parameters:

  errors | Array from which data is copied.

void IG::Neural::NeuralTrainingParameters::SetEpochErrorsRms | ( | List< double > | errors | ) | `[inline]`

Sets the list of sampled RMS errors corresponding to epoch numbers from EpochNumbers.

Parameters:

  errors | List from which data is copied.

void IG::Neural::NeuralTrainingParameters::SetEpochErrorsAbs | ( | double[] | errors | ) | `[inline]`

Sets the list of sampled absolute errors that correspond to epoch numbers from EpochNumbers.

Parameters:

  errors | Array from which data is copied.

void IG::Neural::NeuralTrainingParameters::SetEpochErrorsAbs | ( | List< double > | errors | ) | `[inline]`

Sets the list of sampled absolute errors corresponding to epoch numbers from EpochNumbers.

Parameters:

  errors | List from which data is copied.

void IG::Neural::NeuralTrainingParameters::CopyFrom | ( | NeuralApproximatorBase | nn | ) | `[inline]`

Copies current data from the specified neural network approximator.

Parameters:

  nn | Neural network approximator that data is copied form.

void IG::Neural::NeuralTrainingParameters::CopyResultsFrom | ( | NeuralApproximatorBase | nn | ) | `[inline]`

Copies only results from the trained network to the current object.

Parameters:

  nn | Neural network approximator which results are copied from.

void IG::Neural::NeuralTrainingParameters::CopyTo | ( | NeuralApproximatorBase | nn | ) | `[inline]`

Copies data that determine neural network and training procedure (such as network architecture, training parameters, tolerances, etc.) from the current object to the specified neural network approximator. This enables to restore training contitions of a peviour training procedure.

Parameters:

  nn | Neural network approximator that data is copied to.

static void IG::Neural::NeuralTrainingParameters::SaveJson | ( | NeuralTrainingParameters | trainingParameters,
|  | string | filePath
| ) |  | `[inline, static]`

Saves (serializes) the specified training parameters object to the specified JSON file. File is owerwritten if it exists.

Parameters:

  trainingParameters | Object that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG::Neural::NeuralTrainingParameters::SaveJson | ( | NeuralTrainingParameters | trainingParameters,
|  | string | filePath,
|  | bool | append
| ) |  | `[inline, static]`

Saves (serializes) the specified training parameters object to the specified JSON file.

Parameters:

  trainingParameters | Object that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG::Neural::NeuralTrainingParameters::LoadJson | ( | string | filePath,
|  | ref NeuralTrainingParameters | trainingParametersRestored
| ) |  | `[inline, static]`

Restores (deserializes) a training parameters object from the specified file in JSON format.

Parameters:

  filePath | File from which object data is restored.
  trainingParametersRestored | Object that is restored by deserialization.

static void IG::Neural::NeuralTrainingParameters::SaveJson | ( | NeuralTrainingParameters[] | trainingParameters,
|  | string | filePath
| ) |  | `[inline, static]`

Saves (serializes) the specified array of training parameters objects to the specified JSON file. File is owerwritten if it exists.

Parameters:

  trainingParameters | Array that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG::Neural::NeuralTrainingParameters::SaveJson | ( | NeuralTrainingParameters[] | trainingParameters,
|  | string | filePath,
|  | bool | append
| ) |  | `[inline, static]`

Saves (serializes) the specified array of training parameters objects to the specified JSON file.

Parameters:

  trainingParameters | Array that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG::Neural::NeuralTrainingParameters::LoadJson | ( | string | filePath,
|  | ref NeuralTrainingParameters[] | trainingParametersRestored
| ) |  | `[inline, static]`

Restores (deserializes) an array of training parameters objects from the specified file in JSON format.

Parameters:

  filePath | File from which array of objects is restored.
  trainingParametersRestored | Array of objects that is restored by deserialization.

static void IG::Neural::NeuralTrainingParameters::SaveJson | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | string | filePath
| ) |  | `[inline, static]`

Saves (serializes) the specified list of training parameters objects to the specified JSON file. File is owerwritten if it exists.

Parameters:

  trainingParameters | List that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG::Neural::NeuralTrainingParameters::SaveJson | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | string | filePath,
|  | bool | append
| ) |  | `[inline, static]`

Saves (serializes) the specified list of training parameters objects to the specified JSON file.

Parameters:

  trainingParameters | List that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG::Neural::NeuralTrainingParameters::LoadJson | ( | string | filePath,
|  | ref List< NeuralTrainingParameters > | trainingParametersRestored
| ) |  | `[inline, static]`

Restores (deserializes) a list of training parameters objects from the specified file in JSON format.

Parameters:

  filePath | File from which list of objects is restored.
  trainingParametersRestored | Array of objects that is restored by deserialization.

static void IG::Neural::NeuralTrainingParameters::SaveCSV | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | string | filePath
| ) |  | `[inline, static]`

Saves the specified list of training parameters objects to the specified CSV file.

Parameters:

  trainingParameters | List that is saved to a file.
  filePath | Path to the file into which object is is saved.

$A Tako78 Sep12;

static double IG::Neural::NeuralTrainingParameters::ErrorAverageCalc | ( | List< IVector > | ErrorConvergence,
|  | int | NumLastErrors,
|  | int | NumBundles,
|  | IVector | scalingLength
| ) |  | `[inline, static, protected]`

Calculate average number of the desired number of first elements in the convergence list.

Parameters:

  ErrorConvergence | List of convergence errors.
  NumLastErrors | Number of elemnts in the convergence list.

Returns:
  Average number.

static double IG::Neural::NeuralTrainingParameters::ErrorAverageCalc | ( | List< IVector > | ErrorConvergence,
|  | int | NumLastErrors,
|  | int | NumBundles
| ) |  | `[inline, static, protected]`

Calculate average number of the desired number of first elements in the convergence list.

Parameters:

  ErrorConvergence | List of convergence errors.
  NumLastErrors | Number of elemnts in the convergence list.

Returns:
  Average number.

IComparer<IVector> IG::Neural::NeuralTrainingParameters::CreateComparerErrorTrainingRmsVector | ( |  | ) | `[inline, protected]`

static ComparerTrainingTime IG::Neural::NeuralTrainingParameters::CreateComparerTrainingTime | ( |  | ) | `[inline, static]`

## Member Data Documentation

double IG::Neural::NeuralTrainingParameters::DefaultLearningRate = 0.1`[static]`

Default value for learning rate in neural networks.

double IG::Neural::NeuralTrainingParameters::DefaultMomentum = 0.5`[static]`

Default value of momentum for neural networks.

double IG::Neural::NeuralTrainingParameters::DefaultSigmoidAlphaValue = 1.5`[static]`

Default value of the sigmoid alpha value (used in networks with sigmoid activation functions).

int IG::Neural::NeuralTrainingParameters::DefaultEpochsInBundle`[static]`

Default value for number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between).

int IG::Neural::NeuralTrainingParameters::DefaultNumHiddenLayers = 1`[static]`

Default number of hidden layers.

int IG::Neural::NeuralTrainingParameters::DefaultNumHiddenNeurons = 20`[static]`

Default number of hidden neurons in a layer.

int IG::Neural::NeuralTrainingParameters::DefaultMaxEpochs = 40000`[static]`

Default value for maximal number of epochs.

IVector IG::Neural::NeuralTrainingParameters::DefaultToleranceRms = null`[static]`

Default value for tollerance on RMS error in neural networks.

IVector IG::Neural::NeuralTrainingParameters::DefaultToleranceMax = null`[static]`

Default value for tollerance on max. abs. error in neural networks.

double IG::Neural::NeuralTrainingParameters::DefaultToleranceRmsRelativeToRangeScalar = 0.1`[static]`

Default value for the tolerance on RMS error, relative to the output range.

double IG::Neural::NeuralTrainingParameters::DefaultToleranceMaxRelativeToRangeScalar = 0`[static]`

Default value for the tolerance on max. abs. error, relative to the output range.

int IG::Neural::NeuralTrainingParameters::DefaultInputLength = 1`[static]`

Default number of input neurons.

int IG::Neural::NeuralTrainingParameters::DefaultOutputLength = 1`[static]`

Default number of output neurons.

double IG::Neural::NeuralTrainingParameters::DefaultInputBoundSafetyFactor = 1.5`[static]`

Default number of input safety factor.

double IG::Neural::NeuralTrainingParameters::DefaultOutputBoundSafetyFactor = 1.5`[static]`

Default number of output safety factor.

double IG::Neural::NeuralTrainingParameters::_learningRate = DefaultLearningRate`[protected]`

double IG::Neural::NeuralTrainingParameters::_momentum = DefaultMomentum`[protected]`

double IG::Neural::NeuralTrainingParameters::_sigmoidAlphaValue = DefaultSigmoidAlphaValue`[protected]`

int IG::Neural::NeuralTrainingParameters::_inputLength = DefaultInputLength`[private]`

int IG::Neural::NeuralTrainingParameters::_outputLength = DefaultOutputLength`[private]`

double IG::Neural::NeuralTrainingParameters::_inputBoundSafetyFactor = DefaultInputBoundSafetyFactor`[private]`

Gets or sets input safety factor.

double IG::Neural::NeuralTrainingParameters::_outputBoundSafetyFactor = DefaultOutputBoundSafetyFactor`[private]`

Gets or sets output safety factor.

int IG::Neural::NeuralTrainingParameters::_maxEpochs = DefaultMaxEpochs`[protected]`

int IG::Neural::NeuralTrainingParameters::_epochInBundle = DefaultEpochsInBundle`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_outputRange`[protected]`

IBoundingBox IG::Neural::NeuralTrainingParameters::_outputNeuronRange`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_inputRange`[protected]`

IBoundingBox IG::Neural::NeuralTrainingParameters::_inputNeuronRange`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_toleranceRms`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_toleranceMax`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_tolRmsRelative`[private]`

Auxiliary properties for defining tolerances in a relative way:

double IG::Neural::NeuralTrainingParameters::_tolRmsRelativeScalar = DefaultToleranceRmsRelativeToRangeScalar`[private]`

IVector IG::Neural::NeuralTrainingParameters::_tolMaxRelative`[private]`

double IG::Neural::NeuralTrainingParameters::_tolMaxRelativeScalar = DefaultToleranceMaxRelativeToRangeScalar`[private]`

int IG::Neural::NeuralTrainingParameters::_numHiddenLayers = DefaultNumHiddenLayers`[protected]`

int [] IG::Neural::NeuralTrainingParameters::_numHiddenNeurons = null`[protected]`

bool IG::Neural::NeuralTrainingParameters::_isNetworkTrained = false`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_errorsTrainingRms`[protected]`

List<IVector> IG::Neural::NeuralTrainingParameters::_errorsTrainingRmsList = null

IVector IG::Neural::NeuralTrainingParameters::_errorsTrainingMax`[protected]`

List<IVector> IG::Neural::NeuralTrainingParameters::_errorsTrainingMaxList = null

IVector IG::Neural::NeuralTrainingParameters::_errorsTrainingMeanAbs`[protected]`

IVector IG::Neural::NeuralTrainingParameters::_errorsVerificationRms`[protected]`

List<IVector> IG::Neural::NeuralTrainingParameters::_errorsVerificationRmsList = null

IVector IG::Neural::NeuralTrainingParameters::_errorsVerificationMax`[protected]`

List<IVector> IG::Neural::NeuralTrainingParameters::_errorsVerificationMaxList = null

IVector IG::Neural::NeuralTrainingParameters::_errorsVerificationMeanAbs`[protected]`

bool IG::Neural::NeuralTrainingParameters::_convergenceRmsEnabled = false

int IG::Neural::NeuralTrainingParameters::_numEpochs = 0`[protected]`

double IG::Neural::NeuralTrainingParameters::_trainingTime = 0`[protected]`

double IG::Neural::NeuralTrainingParameters::_trainingCpuTime = 0`[protected]`

List<int> IG::Neural::NeuralTrainingParameters::_EpochNumbers`[protected]`

List<double> IG::Neural::NeuralTrainingParameters::_EpochErrorsRms`[protected]`

List<double> IG::Neural::NeuralTrainingParameters::_EpochErrorsAbs`[protected]`

## Property Documentation

double IG::Neural::NeuralTrainingParameters::LearningRate`[get, set]`

Learning rate.

double IG::Neural::NeuralTrainingParameters::Momentum`[get, set]`

Momentum. Specifies how much changes of weight in the previous iterations affect changes in the current iterations.

double IG::Neural::NeuralTrainingParameters::SigmoidAlphaValue`[get, set]`

Sigmoid alpha value (used in networks with sigmoid activation functions).

virtual int IG::Neural::NeuralTrainingParameters::InputLength`[get, set]`

Gets or sets the number of input neurons.

virtual int IG::Neural::NeuralTrainingParameters::OutputLength`[get, set]`

Gets or sets the number of output neurons.

virtual double IG::Neural::NeuralTrainingParameters::InputBoundSafetyFactor`[get, set]`

Gets or sets input safety factor.

virtual double IG::Neural::NeuralTrainingParameters::OutputBoundSafetyFactor`[get, set]`

Gets or sets output safety factor.

int IG::Neural::NeuralTrainingParameters::MaxEpochs`[get, set]`

Maximal number of epochs performed in the training procedure.

int IG::Neural::NeuralTrainingParameters::EpochsInBundle`[get, set]`

Number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between). This parameter does not affect the training procedure in terms of results.

IVector IG::Neural::NeuralTrainingParameters::OutputRange`[get, set]`

Range from actual outputs.

$A Tako78 Octl12;

IBoundingBox IG::Neural::NeuralTrainingParameters::OutputNeuronRange`[get, set, protected]`

Bounding box from actual outputs.

$A Tako78 Octl12;

IVector IG::Neural::NeuralTrainingParameters::InputRange`[get, set]`

Range from actual inputs.

$A Tako78 Octl12;

IBoundingBox IG::Neural::NeuralTrainingParameters::InputNeuronRange`[get, set, protected]`

Bounding box from actual inputs.

$A Tako78 Octl12;

IVector IG::Neural::NeuralTrainingParameters::ToleranceRms`[get, set]`

Tolerance over RMS error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.

IVector IG::Neural::NeuralTrainingParameters::ToleranceMax`[get, set]`

Tolerance on maximal error of output over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.

IVector IG::Neural::NeuralTrainingParameters::ToleranceRmsRelativeToRange`[get, set]`

Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data.

See also:
  NeuralApproximatorBase.ToleranceRmsRelativeToRange

double IG::Neural::NeuralTrainingParameters::ToleranceRmsRelativeToRangeScalar`[get, set]`

Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value.

See also:
  NeuralApproximatorBase.ToleranceRmsRelativeToRangeScalar

IVector IG::Neural::NeuralTrainingParameters::ToleranceMaxRelativeToRange`[get, set]`

Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data.

See also:
  NeuralApproximatorBase.ToleranceMaxRelativeToRange

double IG::Neural::NeuralTrainingParameters::ToleranceMaxRelativeToRangeScalar`[get, set]`

Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value.

See also:
  NeuralApproximatorBase.ToleranceMaxRelativeToRangeScalar

int IG::Neural::NeuralTrainingParameters::NumHiddenLayers`[get, set]`

Number of Hideden layers.

int [] IG::Neural::NeuralTrainingParameters::NumHidenNeurons`[get, set]`

Numbers of neurons in each hidden layer.

bool IG::Neural::NeuralTrainingParameters::IsNetworkTrained`[get, set]`

Whether the network is trained (and results exist).

IVector IG::Neural::NeuralTrainingParameters::ErrorsTrainingRms`[get, set]`

RMS errors calculated on training data.

List<IVector> IG::Neural::NeuralTrainingParameters::ErrorsTrainingRmsList`[get, set]`

Convergence List of Rms errors calculated on training data.

IVector IG::Neural::NeuralTrainingParameters::ErrorsTrainingMax`[get, set]`

Maximal errors calculated on training data.

List<IVector> IG::Neural::NeuralTrainingParameters::ErrorsTrainingMaxList`[get, set]`

Convergence List of Maximal errors calculated on training data.

IVector IG::Neural::NeuralTrainingParameters::ErrorsTrainingMeanAbs`[get, set]`

Mean absolute errors calculated on training data.

IVector IG::Neural::NeuralTrainingParameters::ErrorsVerificationRms`[get, set]`

RMS errors calculated on verification data.

List<IVector> IG::Neural::NeuralTrainingParameters::ErrorsVerificationRmsList`[get, set]`

Convergence List of RMS errors calculated on verification data.

IVector IG::Neural::NeuralTrainingParameters::ErrorsVerificationMax`[get, set]`

Maximal errors calculated on verification data.

List<IVector> IG::Neural::NeuralTrainingParameters::ErrorsVerificationMaxList`[get, set]`

Convergence List of Maximal errors calculated on verification data.

IVector IG::Neural::NeuralTrainingParameters::ErrorsVerificationMeanAbs`[get, set]`

Maximal errors calculated on training data.

bool IG::Neural::NeuralTrainingParameters::SaveConvergenceRms`[get, set]`

int IG::Neural::NeuralTrainingParameters::NumEpochs`[get, set]`

Number of epochs actually spent at training. This may be less than MaxEpochs if convergence is reached before.

double IG::Neural::NeuralTrainingParameters::TrainingTime`[get, set]`

Time spent for training.

double IG::Neural::NeuralTrainingParameters::TrainingCpuTime`[get, set]`

CPU time spent for training.

List<int> IG::Neural::NeuralTrainingParameters::EpochNumbers`[get, set]`

List of epoch numbers at which convergence data was sampled.

List<double> IG::Neural::NeuralTrainingParameters::EpochErrorsRms`[get, set]`

List of sampled RMS errors corresponding to epoch numbers from EpochNumbers.

List<double> IG::Neural::NeuralTrainingParameters::EpochErrorsAbs`[get, set]`

List of sampled absolute errors corresponding to epoch numbers from EpochNumbers.

The documentation for this class was generated from the following file:

- NeuralTrainingParameters.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events